using ProjectBase.Data.BaseDAL.BaseDatabase;
using ProjectBase.Util;
using SIASUN.Autopilot.DAL.IDALSQL;
using SIASUN.Autopilot.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SIASUN.Autopilot.DAL.DALSQL
{
    public class DalGroupRole : BaseDALSQL<MoGroupRole>, IDalGroupRole
    {
        #region 对象实例及构造函数

        public static DalGroupRole Instance
        {
            get
            {
                return new DalGroupRole(); 
            }
        }
        public DalGroupRole() : base("group_role", new string[] { "group_id" })
        {
            this.sortField = "group_id";
            this.isDescending = false;
        }

        #endregion 

        /// <summary>
        /// 将DataReader的属性值转化为实体类的属性值，返回实体类
        /// </summary>
        /// <param name="dr">有效的DataReader对象</param>
        /// <returns>实体类对象</returns>
        protected override MoGroupRole DataReaderToEntity(IDataReader dataReader)
        {
            MoGroupRole info = new MoGroupRole();
            SmartDataReader reader = new SmartDataReader(dataReader);

            info.GroupId = reader.GetString("group_id");
            info.RoleId = reader.GetString("role_id");
            return info;
        }


        /// <summary>
        /// 将实体对象的属性值转化为Hashtable对应的键值
        /// </summary>
        /// <param name="obj">有效的实体对象</param> 
        /// <returns>包含键值映射的Hashtable</returns>
        protected override Hashtable GetHashByEntity(MoGroupRole obj)
        {
            MoGroupRole info = obj as MoGroupRole;
            Hashtable hash = new Hashtable();

            hash.Add("group_id", info.GroupId);
            hash.Add("role_id", info.RoleId);
            return hash;
        }
    }
}
